package com.njzscloud.supervisory.expense.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.njzscloud.common.core.ex.Exceptions;
import com.njzscloud.common.core.utils.R;
import com.njzscloud.common.mp.support.PageParam;
import com.njzscloud.common.mp.support.PageResult;
import com.njzscloud.supervisory.expense.pojo.entity.ExpenseItemsConfigEntity;
import com.njzscloud.supervisory.expense.service.ExpenseItemsConfigService;
import com.njzscloud.supervisory.order.pojo.entity.OrderExpenseItemsEntity;
import com.njzscloud.supervisory.order.service.OrderExpenseItemsService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 付费项配置
 */
@Slf4j
@RestController
@RequestMapping("/expense_items_config")
@RequiredArgsConstructor
public class ExpenseItemsConfigController {

    private final ExpenseItemsConfigService expenseItemsConfigService;

    private final OrderExpenseItemsService orderExpenseItemsService;

    /**
     * 新增
     */
    @PostMapping("/add")
    public R<?> add(@RequestBody ExpenseItemsConfigEntity expenseItemsConfigEntity) {
        expenseItemsConfigService.add(expenseItemsConfigEntity);
        return R.success();
    }

    /**
     * 修改
     */
    @PostMapping("/modify")
    public R<?> modify(@RequestBody ExpenseItemsConfigEntity expenseItemsConfigEntity) {
        expenseItemsConfigService.modify(expenseItemsConfigEntity);
        return R.success();
    }

    /**
     * 删除
     */
    @PostMapping("/del")
    public R<?> del(@RequestBody List<Long> ids) {
        expenseItemsConfigService.del(ids);
        return R.success();
    }

    /**
     * 详情
     */
    @GetMapping("/detail")
    public R<ExpenseItemsConfigEntity> detail(@RequestParam Long id) {
        return R.success(expenseItemsConfigService.detail(id));
    }

    /**
     * 分页查询
     */
    @GetMapping("/paging")
    public R<PageResult<ExpenseItemsConfigEntity>> paging(PageParam pageParam, ExpenseItemsConfigEntity expenseItemsConfigEntity) {
        return R.success(expenseItemsConfigService.paging(pageParam, expenseItemsConfigEntity));
    }

    /**
     * 通过订单id获取费用清单
     */
    @GetMapping("/orderItemsList")
    public R<List<OrderExpenseItemsEntity>> orderItemsList(@RequestParam Long orderId) {
        if (null == orderId) {
            throw Exceptions.clierr("订单id不能为空");
        }
        return R.success(orderExpenseItemsService.list(Wrappers.lambdaQuery(OrderExpenseItemsEntity.class)
                .eq(OrderExpenseItemsEntity::getOrderId, orderId)
                .eq(OrderExpenseItemsEntity::getDeleted, Boolean.FALSE)));
    }
}
